//+------------------------------------------------------------------+
//|                                             exp_PartClose_v1.mq4 |
//|                                                                * |
//|                                                                * |
//+------------------------------------------------------------------+

/*
       .
   
           .

      ,                . 

Levels -    (  "/")     .              .          ,       .
Percents -   (  "/")   .       .       1.0 ,  50% - 0.5,  25%  1.0 - 0.3   0.2 
LotsDigits -      
Slippage -     
TesterBuy -     -   Buy  
TesterSell -     -   Sell  

*/

#property copyright "Integer"
#property link      "for-good-letters@yandex.ru"

extern string  Levels="10/20/5";//    (  "/")     .              .          ,       .
extern string  Percents="50/25/25"; //   (  "/")   .       .       1.0 ,  50% - 0.5,  25%  1.0 - 0.3   0.2 
extern int     LotsDigits=1;//      
extern int     Slippage=3;//     

extern bool    TesterBuy=false;//    -   Buy  
extern bool    TesterSell=false;//    -   Sell  



//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+

string    gvp; 
int Lev[];
int Per[];
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init(){

   gvp="PartClose_"+Symbol()+"_";
   if(IsTesting())gvp=gvp+"t_";
   if(IsDemo())gvp=gvp+"d_";   
   
      if(IsTesting()){
         for(int i=GlobalVariablesTotal()-1;i>=0;i--){
            if(StringFind(GlobalVariableName(i),gvp,0)==0){
               GlobalVariableDel(GlobalVariableName(i));
            }
         }
      }
   
   string tmpArr[];
   
   fSplitStrToStr(Levels,tmpArr,"/");
   ArrayResize(Lev,ArraySize(tmpArr));
   
      for(i=0;i<ArraySize(tmpArr);i++){
         Lev[i]=StrToInteger(tmpArr[i]);      
      }
      
   fSplitStrToStr(Percents,tmpArr,"/");
   ArrayResize(Per,ArraySize(tmpArr));
   
      for(i=0;i<ArraySize(tmpArr);i++){
         Per[i]=StrToInteger(tmpArr[i]); 
         Print(Per[i]);     
      }   
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----

      if(IsTesting()){
         for(int i=GlobalVariablesTotal()-1;i>=0;i--){
            if(StringFind(GlobalVariableName(i),gvp,0)==0){
               GlobalVariableDel(GlobalVariableName(i));
            }
         }
      }

   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----

   if(IsTesting()){
      if(OrdersTotal()==0){
         if(TesterBuy)OrderSend(Symbol(),OP_BUY,1.0,NormalizeDouble(Ask,Digits),0,NormalizeDouble(Ask-Point*20,Digits),0,NULL,0,0,CLR_NONE);
         if(TesterSell)OrderSend(Symbol(),OP_SELL,1.0,NormalizeDouble(Bid,Digits),0,NormalizeDouble(Bid+Point*20,Digits),0,NULL,0,0,CLR_NONE);
      }
   }

  
      for(int i=OrdersTotal()-1;i>=0;i--){
         if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
            if(OrderSymbol()==Symbol()){
               int ParentTicket=0;
               int oNum=0;
               double oLots=OrderLots();
                  if(StringFind(OrderComment(),"split from #",0)==0){
                     ParentTicket=StrToInteger(StringSubstr(OrderComment(),12,StringLen(OrderComment())-12));
                  }
                  if(ParentTicket!=0){
                     if(GlobalVariableCheck(gvp+ParentTicket+"_Num")){
                        oNum=GlobalVariableGet(gvp+ParentTicket+"_Num")+1;
                     }
                     if(GlobalVariableCheck(gvp+ParentTicket+"_Lots")){
                        oLots=GlobalVariableGet(gvp+ParentTicket+"_Lots");
                     }  
                  }
               GlobalVariableSet(gvp+OrderTicket()+"_Num",oNum);
               GlobalVariableSet(gvp+OrderTicket()+"_Lots",oLots);
               if(oNum>=ArraySize(Lev))oNum=ArraySize(Lev)-1;
               RefreshRates();
                  if(OrderType()==OP_BUY){
                     if(ND(Bid-OrderOpenPrice())>=ND(Point*Lev[oNum])){
                        double LotsClose=NormalizeDouble(Per[oNum]*oLots/100.0,LotsDigits); 
                           if(LotsClose>0){
                              LotsClose=MathMin(LotsClose,OrderLots());                           
                                 if(!OrderClose(OrderTicket(),LotsClose,ND(Bid),Slippage,CLR_NONE)){
                                    Print("Close error "+GetLastError());
                                 }
                           }
                     }
                  }
                  if(OrderType()==OP_SELL){
                     if(ND(OrderOpenPrice()-Ask)>=ND(Point*Lev[oNum])){
                        LotsClose=NormalizeDouble(Per[oNum]*oLots/100.0,LotsDigits);                      
                           if(LotsClose>0){
                              LotsClose=MathMin(LotsClose,OrderLots());
                                 if(!OrderClose(OrderTicket(),LotsClose,ND(Ask),Slippage,CLR_NONE)){
                                    Print("Close error "+GetLastError());                         
                                 }
                           }
                     }                  
                  }                  
            }
         }
         else{
            return(0);
         }
      }   
//----
   return(0);
  }
//+------------------------------------------------------------------+

double ND(double v){return(NormalizeDouble(v,Digits));}

int fSplitStrToStr(string aString,string & aArray[],string aDelimiter){
string tmp_str="";
string tmp_char="";
ArrayResize(aArray,0);
   for(int i=0;i<StringLen(aString);i++){
      tmp_char=StringSubstr(aString,i,1);
         if(tmp_char==aDelimiter){
               if(StringTrimLeft(StringTrimRight(tmp_str))!=""){
                  ArrayResize(aArray,ArraySize(aArray)+1);
                  aArray[ArraySize(aArray)-1]=tmp_str;
               }
            tmp_str="";
         }
         else{
            if(tmp_char!=" ")tmp_str=tmp_str+tmp_char;
         }
   }
   if(StringTrimLeft(StringTrimRight(tmp_str))!=""){
      ArrayResize(aArray,ArraySize(aArray)+1);
      aArray[ArraySize(aArray)-1]=tmp_str;
   } 
return(ArraySize(aArray));
}

